from lib.myqueue import MyQueue
import pygtk
pygtk.require('2.0')
import gobject
import gtk
import pango


class MyGuiQueue(MyQueue):


    def __init__(self, maxsize=0):
        MyQueue.__init__(self, maxsize)
        self.notebook = gtk.Notebook()


    def initNoteBook(self):
        return self.notebook


    def periodicCall(self):
        self.processIncoming()
        gobject.timeout_add(100, self.periodicCall)


    def initCompany(self, name):
        frame = gtk.Frame()
        s = gtk.ScrolledWindow()
        t = gtk.TextView()
        t.modify_base(gtk.STATE_NORMAL, gtk.gdk.Color(255,0,0))
        t.modify_font(pango.FontDescription('monospace'))
        t.set_editable(False)
        t.set_cursor_visible(False)
        t.show()
        s.add(t)
        s.show()
        frame.add(s)
        frame.show()

        if name:
            self.notebook.append_page(frame, gtk.Label(name))
        else:
            self.notebook.append_page(frame, gtk.Label(''))

        return (self.notebook.get_n_pages() - 1), t


    def setCompanyName(self, company_id, name):
        self.notebook.set_tab_label_text(self.notebook.get_nth_page(company_id), name)


    def completeCompany(self, company_id, name):
        label = "[ %s ]*" % name
        self.notebook.set_tab_label_text(self.notebook.get_nth_page(company_id), label)


    def createTag(self, stream, tagname, **kwargs):
        return stream.get_buffer().create_tag(tagname, **kwargs)


    def outputText(self, stream, text, tags, tagname, isnew):
        stream_buffer = stream.get_buffer()
        position = stream_buffer.get_end_iter()
        if isnew:
            stream_buffer.insert_with_tags(position, text, tags[tagname])
        else:
            stream_buffer.insert_with_tags_by_name(position, text, tagname)
        stream.scroll_to_mark(stream_buffer.get_insert(), 0.0, True, 0.5, 0.5)
